'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactTappable = require('react-tappable');

var _reactTappable2 = _interopRequireDefault(_reactTappable);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var TapLink = function TapLink(props, context) {

  return _extends({}, _react2['default'].Component.prototype, {
    props: props,
    context: context,

    handleTap: function handleTap() {
      var redirectType = this.props.redirectType;
      var router = this.context.router;

      if (redirectType === 'transition') {
        router.transitionTo(this.props.to, this.props.params, this.props.query);
      } else if (redirectType === 'replace') {
        router.replaceWith(this.props.to, this.props.params, this.props.query);
      } else {
        throw new Error('Unsupported redirect type "' + redirectType + '" given');
      }
    },

    getClassName: function getClassName() {
      var className = this.props.className;

      if (this.getActiveState()) {
        className += ' ' + this.props.activeClassName;
      }

      return className;
    },

    getActiveState: function getActiveState() {
      return this.context.router.isActive(this.props.to, this.props.params, this.props.query);
    },

    render: function render() {
      var component = this.props.component;

      return _react2['default'].createElement(
        _reactTappable2['default'],
        { onTap: this.handleTap.bind(this), component: component, className: this.getClassName() },
        this.props.children
      );
    }
  });
};

TapLink.propTypes = {
  activeClassName: _react2['default'].PropTypes.string.isRequired,
  to: _react2['default'].PropTypes.string.isRequired,
  params: _react2['default'].PropTypes.object,
  query: _react2['default'].PropTypes.object,
  activeStyle: _react2['default'].PropTypes.object,
  component: _react2['default'].PropTypes.string,
  redirectType: _react2['default'].PropTypes.string.isRequired
};

TapLink.defaultProps = {
  activeClassName: 'active',
  className: '',
  component: 'a',
  redirectType: 'transition'
};

TapLink.contextTypes = {
  router: _react2['default'].PropTypes.func.isRequired
};

exports['default'] = TapLink;
module.exports = exports['default'];